/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the NotificationAssetsList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NotificationAssetsList{}

// NotificationAssetsList struct for NotificationAssetsList
type NotificationAssetsList struct {
	Results []NotificationAsset `json:"results,omitempty"`
	Total *int32 `json:"total,omitempty"`
}

// NewNotificationAssetsList instantiates a new NotificationAssetsList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNotificationAssetsList() *NotificationAssetsList {
	this := NotificationAssetsList{}
	return &this
}

// NewNotificationAssetsListWithDefaults instantiates a new NotificationAssetsList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNotificationAssetsListWithDefaults() *NotificationAssetsList {
	this := NotificationAssetsList{}
	return &this
}

// GetResults returns the Results field value if set, zero value otherwise.
func (o *NotificationAssetsList) GetResults() []NotificationAsset {
	if o == nil || IsNil(o.Results) {
		var ret []NotificationAsset
		return ret
	}
	return o.Results
}

// GetResultsOk returns a tuple with the Results field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NotificationAssetsList) GetResultsOk() ([]NotificationAsset, bool) {
	if o == nil || IsNil(o.Results) {
		return nil, false
	}
	return o.Results, true
}

// HasResults returns a boolean if a field has been set.
func (o *NotificationAssetsList) HasResults() bool {
	if o != nil && !IsNil(o.Results) {
		return true
	}

	return false
}

// SetResults gets a reference to the given []NotificationAsset and assigns it to the Results field.
func (o *NotificationAssetsList) SetResults(v []NotificationAsset) {
	o.Results = v
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *NotificationAssetsList) GetTotal() int32 {
	if o == nil || IsNil(o.Total) {
		var ret int32
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NotificationAssetsList) GetTotalOk() (*int32, bool) {
	if o == nil || IsNil(o.Total) {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *NotificationAssetsList) HasTotal() bool {
	if o != nil && !IsNil(o.Total) {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int32 and assigns it to the Total field.
func (o *NotificationAssetsList) SetTotal(v int32) {
	o.Total = &v
}

func (o NotificationAssetsList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NotificationAssetsList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Results) {
		toSerialize["results"] = o.Results
	}
	if !IsNil(o.Total) {
		toSerialize["total"] = o.Total
	}
	return toSerialize, nil
}

type NullableNotificationAssetsList struct {
	value *NotificationAssetsList
	isSet bool
}

func (v NullableNotificationAssetsList) Get() *NotificationAssetsList {
	return v.value
}

func (v *NullableNotificationAssetsList) Set(val *NotificationAssetsList) {
	v.value = val
	v.isSet = true
}

func (v NullableNotificationAssetsList) IsSet() bool {
	return v.isSet
}

func (v *NullableNotificationAssetsList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNotificationAssetsList(val *NotificationAssetsList) *NullableNotificationAssetsList {
	return &NullableNotificationAssetsList{value: val, isSet: true}
}

func (v NullableNotificationAssetsList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNotificationAssetsList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


